from django.db import models

# Create your models here.


class YearInSchool(models.TextChoices):
    FRESHMAN = "FR", "Freshman"
    SOPHOMORE = "SO", "Sophomore"
    JUNIOR = "JR", "Junior"
    SENIOR = "SR", "Senior"
    GRADUATE = "GR", "Graduate"


class Student(models.Model):
    name = models.CharField(max_length=100, help_text="学生姓名")
    year_in_school = models.CharField(
        max_length=2,
        choices=YearInSchool.choices,
        default=YearInSchool.FRESHMAN,
        help_text="该学生所在的学年",
    )
    date_of_birth = models.DateField(help_text="该学生的生日")
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    class Meta:
        ordering = ["created_at"]
